package assignment02;

/**
 * Assignment 02: 
 *          Circle: The Circle class that makes use of a Point class. (for
 *                  the second part of the assignment)
 */

public class Circle {

    // Fields
    
    private Point center;   // center
    private double r;   // radius

    // *Constructor*s
    // You should note that the Point object should be encapsulated by
    // the Circle. That's why a private object is created and 
    // maintained by the Circle. No matter how the coordinates for the 
    // center is sent to this class, a new Point object is created.
    // QUESTION: What other options are there? What is the diff?
    // *Contructor* (the method to follow for instantiating objects
    // Create a Circle at the specified coordinates and with the  
    //   given radius.
    public Circle(double x, double y, double r) {
        this.center = new Point(x, y);
        this.r = r;
    }

    // *constructor* - *overloading*
    // An alternative constructor when we have a Point as the center.
    public Circle(Point anyPoint, double r) {
        // the real WORK is done by the first constructor...
        // we only extract the coordinates here.
        this(anyPoint.x(), anyPoint.y(), r);
    }

    // *constructor* - *overloading*
    // An alternative constructor for when the center Point is known   
    // but the radius is unspecified.
    public Circle(Point n) {
        // pass the work on...
        // assume unit circle
        this(n.x(), n.y(), 1.0);
    }

    // *default constructor* - *overloading*
    public Circle() {
        // assume unit circle at Origin
        this(0.0, 0.0, 1.0);
    }

    // Other Methods
    
    // where is the center of this Circle?
    public Point center() {
        return center;
    }

    // what is the radius of this Circle?
    public double radius() {
        return r;
    }

    // Calculate the circumference of this circle
    public double circumference() {
        // no need to define temporary variables
        // (although we did in the first part)
        return 2 * Math.PI * r;
    }

    // Calculate the area of this circle
    public double area() {
        return Math.PI * r * r;
    }

    // Is the specified point inside or outside this circle?
    //   We measure the distance between the point and the center 
    //   and compare it with the radius. The answer is either true
    //   or false.
    public boolean isPointInside(double point_x, double point_y) {
        double delta_x = point_x - center.x();
        double delta_y = point_y - center.y();
        // no need for the distance variable
        // but it is more readable and understandable
        double distance = Math.sqrt(delta_x * delta_x + delta_y * delta_y);
        if (distance < r) {
            return true;
        } else {
            return false;
        }
    }

    // if the "client" has a Point object and wants to send
    // that directly, we should provide a more convenient
    // method: Another *Overloading* example
    public boolean isPointInside(Point n) {
        return Circle.this.isPointInside(n.x(), n.y());
    }
}

