package assignment02;

/**
 * Assignment 02: 
 *          Point: Simple Point class for the second part of the
 *                 assignment
 */

public class Point {

    // Fields
    
    private double x;   // x coordinate 
    private double y;   // y coordinate 

    // Methods
    
    // *Constructor* method to follow for instantiating objects
    // We are creating a point with the coordinates sent to us.
    public Point(double x, double y) {
        this.x = x;
        this.y = y;
    }

    // *default constructor* - *overloading*
    //   we call the first constructor above to create the 
    //   new Point at the Origin.
    public Point() {
        this(0.0, 0.0);
    }

    // "get" the X coordinate (because the field is private)
    public double x() {
        return x;
    }

    // "get" the y coordinate
    public double y() {
        return y;
    }

    // "set" the x coordinate
    public void x(double x) {
        // note the effect of scope on variables
        // "x" declared as the parameter (argument) 
        // overrides the "x" that is the field of the class
        // "this" is required to differentiate the two
        this.x = x;
    }

    // "set" the y coordinate
    public void y(double y) {
        this.y = y;
    }

    // "set" new values for both coordinates
    public void move(double x, double y) {
        this.x = x;
        this.y = y;
    }

}
