package assignment02;

/**
 * Assignment 02: 
 *          SimpleCircleApplication: An application that uses the Circle
 *                      class written for the first part of the assignment.
 */

public class SimpleCircleApplication {

    public static void main(String[] args) {

        System.out.println("SimpleCircleApplication - begin\n");

        System.out.println("Circle 1:");

        // Let's create a new Object.
        SimpleCircle c1 = new SimpleCircle();
        // since the fields are public we can directly assign
        // values. 
        c1.x = 0.0;
        c1.y = 0.0;
        c1.r = 3.5;
        // calculate the required values
        double circumference1 = c1.circumference();
        double area1 = c1.area();
        // assume the point of interest is at 2.3, 0.2 
        boolean isInside1 = c1.isPointInside(2.3, 0.2);

        // now we have enough info on the first circle
        // let's report it 
        System.out.println("  Center: " + c1.x + ", " + c1.y);
        System.out.println("  Radius: " + c1.r);
        System.out.println("  Area  : " + area1);
        System.out.println("  Circumference: " + circumference1);
        System.out.print("  Point at 2.3,0.2 is ");
        if (isInside1) {
            System.out.println("INSIDE the circle.\n");
        } else {
            System.out.println("OUTSIDE the circle.\n");
        }

        System.out.println("Circle 2:");
        // Create the second circle. 
        // This time we assign values to parameters as we create it..
        SimpleCircle c2 = new SimpleCircle(1.0, 2.0, 3.0);
        // we can calculate and immediately report the value
        System.out.println("  Center: " + c2.x + ", " + c2.y);
        System.out.println("  Radius: " + c2.r);
        System.out.println("  Area  : " + c2.area());
        System.out.println("  Circumference: " + c2.circumference());
        System.out.print("  Point at 2.3,0.2 is  ");
        if (c2.isPointInside(2.3, 0.2)) {
            System.out.println("INSIDE the circle.\n");
        } else {
            System.out.println("OUTSIDE the circle.\n");
        }

        System.out.println("Circle 3:");
        // We are done with the second circle. Since we are
        // not need to remember it, we can use the same Object
        // and just update the fields to represent the third 
        // Circle. 
        // This is similar to using move() and resize() methods.
        c2.x = 5.0;
        c2.y = 5.0;
        c2.r = 1.0;
        // Report the values
        System.out.println("  Center: " + c2.x + ", " + c2.y);
        System.out.println("  Radius: " + c2.r);
        System.out.println("  Area  : " + c2.area());
        System.out.println("  Circumference: " + c2.circumference());
        System.out.print("  Point at 2.3,0.2 is ");
        if (c2.isPointInside(2.3, 0.2)) {
            System.out.println("INSIDE the circle.\n");
        } else {
            System.out.println("OUTSIDE the circle.\n");
        }

        System.out.println("Circle 4:");
        // we have used  the same object to represent the second and 
        // third circles. Another alternative is to create a brand new 
        // object instead.
        // But we can keep using the same variable (type: Circle) as a 
        // reference. 
        c2 = new SimpleCircle(8.0, 15.5, 12.5);
        // report the values
        System.out.println("  Center: " + c2.x + ", " + c2.y);
        System.out.println("  Radius: " + c2.r);
        System.out.println("  Area  : " + c2.area());
        System.out.println("  Circumference: " + c2.circumference());
        System.out.print("  Point at 2.3,0.2 is ");
        if (c2.isPointInside(2.3, 0.2)) {
            System.out.println("INSIDE the circle.\n");
        } else {
            System.out.println("OUTSIDE the circle.\n");
        }

        System.out.println("Circle 5:");
        // Let's not define values to the fields. The radius and
        // the coordinates of the center will not be assigned below.
        // The *default constructor* in the Class assigns default
        // values to the parameters ensuring the application runs
        // without an error.
        c2 = new SimpleCircle();
        // report values (remember: these will be defaults)
        System.out.println("  Center: " + c2.x + ", " + c2.y);
        System.out.println("  Radius: " + c2.r);
        System.out.println("  Area  : " + c2.area());
        System.out.println("  Circumference: " + c2.circumference());
        System.out.print("  Point at 2.3,0.2 is ");
        if (c2.isPointInside(2.3, 0.2)) {
            System.out.println("INSIDE the circle.\n");
        } else {
            System.out.println("OUTSIDE the circle.\n");
        }

        System.out.println("SimpleCircleApplication - end\n");

    }

}
